/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-naoqi-msgs-0.4.7-0quantal-20150331-0810/srv/SetArmsEnabled.srv
 *
 */


#ifndef NAOQI_MSGS_MESSAGE_SETARMSENABLEDREQUEST_H
#define NAOQI_MSGS_MESSAGE_SETARMSENABLEDREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace naoqi_msgs
{
template <class ContainerAllocator>
struct SetArmsEnabledRequest_
{
  typedef SetArmsEnabledRequest_<ContainerAllocator> Type;

  SetArmsEnabledRequest_()
    : left_arm(false)
    , right_arm(false)  {
    }
  SetArmsEnabledRequest_(const ContainerAllocator& _alloc)
    : left_arm(false)
    , right_arm(false)  {
    }



   typedef uint8_t _left_arm_type;
  _left_arm_type left_arm;

   typedef uint8_t _right_arm_type;
  _right_arm_type right_arm;




  typedef boost::shared_ptr< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetArmsEnabledRequest_

typedef ::naoqi_msgs::SetArmsEnabledRequest_<std::allocator<void> > SetArmsEnabledRequest;

typedef boost::shared_ptr< ::naoqi_msgs::SetArmsEnabledRequest > SetArmsEnabledRequestPtr;
typedef boost::shared_ptr< ::naoqi_msgs::SetArmsEnabledRequest const> SetArmsEnabledRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace naoqi_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'nav_msgs': ['/opt/ros/hydro/share/nav_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'naoqi_msgs': ['/tmp/buildd/ros-hydro-naoqi-msgs-0.4.7-0quantal-20150331-0810/msg', '/tmp/buildd/ros-hydro-naoqi-msgs-0.4.7-0quantal-20150331-0810/obj-i686-linux-gnu/devel/share/naoqi_msgs/msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "4da9069facca935244c3405e288ba555";
  }

  static const char* value(const ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x4da9069facca9352ULL;
  static const uint64_t static_value2 = 0x44c3405e288ba555ULL;
};

template<class ContainerAllocator>
struct DataType< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "naoqi_msgs/SetArmsEnabledRequest";
  }

  static const char* value(const ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
bool left_arm\n\
bool right_arm\n\
";
  }

  static const char* value(const ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.left_arm);
      stream.next(m.right_arm);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetArmsEnabledRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::naoqi_msgs::SetArmsEnabledRequest_<ContainerAllocator>& v)
  {
    s << indent << "left_arm: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.left_arm);
    s << indent << "right_arm: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.right_arm);
  }
};

} // namespace message_operations
} // namespace ros

#endif // NAOQI_MSGS_MESSAGE_SETARMSENABLEDREQUEST_H
